#include <bits/stdc++.h>
using namespace std;
    string a, b[100001];
    long long n, m, p, l;
int main (){
ios_base::sync_with_stdio(false);
cin.tie(0);
cout.tie(0);
    long long i, j;
    cin >> a;
    n=a.length();
    cin >> m;
    for (i=0; i<m; i++){
        cin >> b[i];
    }
    int l=0;
    while (l!=a.length()-1){
        l=a.length()-1;
        int len;
        for (i=0; i<m; i++){
            p=a.substr(0,l).find(b[i]);
            if (p!=string::npos){
                l=p;
                len=b[i].size();
            }
        }
        a.erase(l, len);
    }
        cout << a << endl;

return 0;
}
